public class Countprimes4 {
    
    private static int steps;

    public static void main(String[] args) {
        if (args.length != 1) {
            System.out.println("Usage: java Countprimes4 <limit>");
            return;
        }
        long limit = Long.parseLong(args[0]);
        int numPrimes = 0;
        long biggest = 0;
        System.out.println("Counting primes using primeTest4...");
        for (long n = 2; n <= limit; n++) {
            steps = 0;
            if (primeTest4(n) == true) {
                System.out.printf("%d is prime - took %d steps\n", n, steps);
                numPrimes++;
                biggest = n;
            }
        }
        System.out.printf("Found %d primes less than or equal to %d\n", numPrimes, limit);
        System.out.printf("Biggest prime is %d\n", biggest);
    }
    
    //-------------------------------------------------------------------

    public static boolean primeTest4(long n) {
        if (n < 2) return false;
        if (n == 2) return true;
        if (n % 2 == 0) return false;
        long squareRoot = (long) Math.sqrt(n);
        for (long i = 3; i <= squareRoot; i += 2) {
            steps++;
            if (n % i == 0) return false;
        }
        return true;
    }
}
