public class Countprimes6 {
    
    private static int steps;

    public static void main(String[] args) {
        if (args.length != 1) {
            System.out.println("Usage: java Countprimes6 <limit>");
            return;
        }
        long limit = Long.parseLong(args[0]);
        int numPrimes = 0;
        long biggest = 0;
        System.out.println("Counting primes using primeTest6...");
        for (long n = 2; n <= limit; n++) {
            steps = 0;
            if (primeTest6(n) == true) {
                System.out.printf("%d is prime - took %d steps\n", n, steps);
                numPrimes++;
                biggest = n;
            }
        }
        System.out.printf("Found %d primes less than or equal to %d\n", numPrimes, limit);
        System.out.printf("Biggest prime is %d\n", biggest);
    }
    
    //-------------------------------------------------------------------
    // the Fermat test

    public static boolean primeTest6(long n) {
        int TRIALS = 10;
        if (n < 2) return false;
        for (int i = 1; i <= TRIALS; i++) {
            steps++;
            long a = pickRandom(1, n-1);
            if (fastpowerModulo(a, n, n) != a) return false;
        }
        return true;
    }
    
    // fast exponentiation, modulo M
    public static long fastpowerModulo(long b, long n, long M) {
        steps++;
        if (n == 0) {
            return 1;
        } else if (isEven(n)) {
            return square(fastpowerModulo(b, n/2, M)) % M;
        } else {
            return times(b, fastpowerModulo(b, n-1, M)) % M;
        }
    }

    public static boolean isEven(long n) {
        return (n % 2 == 0);
    }

    public static long square(long n) {
        return n * n;
    }

    public static long times(long b, long n) {
        return b * n;
    }

    // return a random integer in the range start to end, inclusive
    public static long pickRandom(long start, long end) {
        return start + (long) Math.round(Math.random() * (end - start));
    }
}
